## xorp 1.5

=== docs/papers/hotnets_2002_paper/Makefile ===
LATEX = latex
BIBTEX = bibtex
PDFLATEX = pdflatex
METAPOST = mpost
DVIPS = dvips -j0
PS2PDF = ps2pdf

.SUFFIXES: pdf ps dvi tex
.ps.pdf:
	$(PS2PDF) $< $@
.dvi.ps:
	$(DVIPS) $< -o $@
.tex.dvi:
	@if [ ! -r $(subst tex,aux,$<) ]; then $(LATEX) $<; fi
	$(LATEX) $<

# after making the figure, run perl to fix CMR font names
fig/%.1 fig/%.2 fig/%.3 fig/%.4 fig/%.5 fig/%.6 fig/%.7 fig/%.8: fig/%.mp fig/elements.mp fig/elemfig.sty .fonts.sty fig/fonts.mp
	cd fig ; TEX=$(LATEX) $(METAPOST) $(subst fig/,,$<)
	perl -pi -e 'next if $$x; $$x = 1 if /%%EndProlog/; s=/([a-z][a-z0-9]+) def=/\U$$1\E def= if !/^%%/; s=\b([a-z][a-z0-9]+)\b=\U$$1\E=g if /^%%DocumentFonts/ || /^%%\+/;' $(subst .mp,,$<).[0-9]*

FIGS =
TEXSRCS = pospaper.tex intro.tex overview.tex xorp.tex platform.tex summary.tex

all: dvi ps pdf
dvi: pospaper.dvi
ps: pospaper.ps
pdf: pospaper.pdf

pospaper.pdf: pospaper.ps
	$(PS2PDF) $< $@
pospaper.ps: pospaper.dvi
	$(DVIPS) $< -o $@
pospaper.dvi: $(TEXSRCS) $(FIGS) pospaper.bbl always
pospaper.aux: $(TEXSRCS)
	$(LATEX) $<

bib: pospaper.aux always
	$(BIBTEX) -min-crossrefs=100 pospaper
pospaper.bbl: pospaper.aux biblio.bib
	$(BIBTEX) -min-crossrefs=100 pospaper

fig/fonts.mp:
	echo 'defaultelementfont := "ptmr";' > fig/fonts.mp
.fonts.sty: fonts.sty
	rm -f fig/*.mpx
	cp fonts.sty .fonts.sty

always:
	@:
clean: cleanfig
	rm -f paper.pdf paper.dvi paper.aux paper.log paper.bbl paper.blg
cleanfig:
	/bin/rm -f $(FIGS) fig/*.log fig/*.aux fig/*.dvi fig/*.mpx

.PHONY: all dvi pdf bib always clean cleanfig allpdf

=== docs/papers/lcs2004_paper/Makefile ===
LATEX = latex
BIBTEX = bibtex
PDFLATEX = pdflatex
METAPOST = mpost
DVIPS = dvips -j0
PS2PDF = ps2pdf

.SUFFIXES: pdf ps dvi tex
.ps.pdf:
	$(PS2PDF) $< $@
.dvi.ps:
	$(DVIPS) $< -o $@
.tex.dvi:
	@if [ ! -r $(subst tex,aux,$<) ]; then $(LATEX) $<; fi
	$(LATEX) $<

# after making the figure, run perl to fix CMR font names
fig/%.1 fig/%.2 fig/%.3 fig/%.4 fig/%.5 fig/%.6 fig/%.7 fig/%.8: fig/%.mp fig/elements.mp fig/elemfig.sty .fonts.sty fig/fonts.mp
	cd fig ; TEX=$(LATEX) $(METAPOST) $(subst fig/,,$<)
	perl -pi -e 'next if $$x; $$x = 1 if /%%EndProlog/; s=/([a-z][a-z0-9]+) def=/\U$$1\E def= if !/^%%/; s=\b([a-z][a-z0-9]+)\b=\U$$1\E=g if /^%%DocumentFonts/ || /^%%\+/;' $(subst .mp,,$<).[0-9]*

FIGS =
TEXSRCS = lcspaper.tex intro.tex vision.tex summary.tex acknowledgments.tex

all: dvi ps pdf
dvi: lcspaper.dvi
ps: lcspaper.ps
pdf: lcspaper.pdf

lcspaper.pdf: lcspaper.ps
	$(PS2PDF) $< $@
lcspaper.ps: lcspaper.dvi
	$(DVIPS) $< -o $@
lcspaper.dvi: $(TEXSRCS) $(FIGS) lcspaper.bbl always
lcspaper.aux: $(TEXSRCS)
	$(LATEX) $<

bib: lcspaper.aux always
	$(BIBTEX) -min-crossrefs=100 lcspaper
lcspaper.bbl: lcspaper.aux biblio.bib
	$(BIBTEX) -min-crossrefs=100 lcspaper

fig/fonts.mp:
	echo 'defaultelementfont := "ptmr";' > fig/fonts.mp
.fonts.sty: fonts.sty
	rm -f fig/*.mpx
	cp fonts.sty .fonts.sty

always:
	@:
clean: cleanfig
	rm -f paper.pdf paper.dvi paper.aux paper.log paper.bbl paper.blg
cleanfig:
	/bin/rm -f $(FIGS) fig/*.log fig/*.aux fig/*.dvi fig/*.mpx

.PHONY: all dvi pdf bib always clean cleanfig allpdf

## xorp 1.8.3

=== SConstruct ===
#Copyright (c) 2009-2011 XORP, Inc and Others
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, Version 2, June
# 1991 as published by the Free Software Foundation. Redistribution
# and/or modification of this program under the terms of any other
# version of the GNU General Public License is not permitted.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. For more details,
# see the GNU General Public License, Version 2, a copy of which can be
# found in the XORP LICENSE.gpl file.
#
# XORP Inc, 2953 Bunker Hill Lane, Suite 204, Santa Clara, CA 95054, USA;
# http://xorp.net

# $ID$

# TODO cross compiles.
# TODO Fix default include/lib paths, pass in from environment.
# TODO Merge scons-unfamiliar syntactic sugar from YHC's sconsfiles.

import relpath

gnutoolwarning = """
WARNING: The GNU %s was not detected on your system.
Some combinations of linker or compiler flags, specific to building XORP,
may not function correctly.
"""

# The XRL tgt-gen and clnt-gen scripts use Python 2.3+'s optparse
# class. However, os.path.relpath() requires Python 2.6.
EnsurePythonVersion(2, 3)

Help("""
    builddir=<some path> to specify a different build directory.
        Default is "obj/<arch>-<os>-<rel>".
""")

import sys
import os
import string
import subprocess
import fnmatch

import SCons
from SCons.Script.SConscript import SConsEnvironment
import SCons.Action
import SCons.Builder

try:
    # SCons 0.98.4 is the earliest release that we have tested.  Earlier
    # ones may work.  If so, please submit a Trac issue so the check can
    # be relaxed.
    EnsureSConsVersion(0, 98, 4)
except SystemExit:
    print "WARNING:  Actually, SCONS version 0.98.4 or later is _preferred_."
    print "Attempting to continue with version: " + SCons.__version__ + " but it may not work properly.\n"


vars = Variables()

vars.AddVariables(
    BoolVariable('shared', 'Build with shared libraries', True),
    BoolVariable('strip',  'Strip all installed binaries', False),
    BoolVariable('rtld_origin', 'Use ORIGIN in dynamically linked programs', True),
    BoolVariable('ignore_check_errors', 'Ignore errors when building tests', False),
    BoolVariable('debug_stl',  'Build with checked STL operations', False),
    BoolVariable('debug_msg',  'Build with debug messages', False),
    BoolVariable('debug_fn',  'Build with function names in debug_msg output', False),
    BoolVariable('debug_cb',  'Build with callback debugging', False),
    BoolVariable('disable_ipv6',  'Force disable of IPv6', False),
    BoolVariable('disable_libtecla',  'Use some externally compiled libtecla instead.', False),
    BoolVariable('disable_fw',  'Disable Firewall feature', False),
    BoolVariable('disable_warninglogs',  'Force disable warning logs', False),
    BoolVariable('disable_tracelogs',  'Force disable trace logs', False),
    BoolVariable('disable_fatallogs',  'Force disable fatal logs', False),
    BoolVariable('disable_infologs',  'Force disable info logs', False),
    BoolVariable('disable_assertlogs',  'Force disable assert logs', False),
    BoolVariable('disable_errorlogs',  'Force disable error logs', False),
    BoolVariable('disable_otherlogs',  'Force disable other logs', False),
    BoolVariable('disable_profile',  'Disable Xorp Profiler feature', False),
    BoolVariable('enable_boost',  'Use BOOST', False),
    BoolVariable('enable_ustl',  'Use uSTL', False),
    BoolVariable('enable_bgp',  'Build BGP', True),
    BoolVariable('enable_olsr',  'Build OLSR', True),
    BoolVariable('enable_ospf',  'Build OSPF', True),
    BoolVariable('enable_rip',  'Build RIP', True),
    BoolVariable('enable_vrrp',  'Build VRRP', True),
    BoolVariable('enable_xorpsh',  'Build xorpsh', True),
    BoolVariable('enable_tests',  'Build Test Programs', False),
    BoolVariable('enable_click',  'Build CLICK support', False),
    BoolVariable('enable_fea_dummy',  'Build fea-dummy target', True),
    BoolVariable('debug_xrldb',  'Build with runtime XRL syntax validation in Router Manager', False),
    EnumVariable('debug', 'Build with debug symbols', 'full',
                 allowed_values=('no', 'yes', 'full', 'override'),
                 map={}, ignorecase=2),
    EnumVariable('optimize', 'Build with optimization', 'yes',
                 allowed_values=('no', 'minimal', 'yes', 'full', 'highest',
                                 'size', 'override'),
                 map={}, ignorecase=2),
    EnumVariable('profile', 'Build with profiling', 'no',
                 allowed_values=('no', 'gprof', 'pprof', 'override'),
                 map={}, ignorecase=2),
    EnumVariable('transport', 'Set default XRL transport protocol', 'local',
                  allowed_values=('tcp', 'local'),
                  map={}, ignorecase=2),
    PathVariable('prefix', 'Install prefix',
                 '/usr/local/xorp', PathVariable.PathAccept),
    )

def log_args(afname):
    f = open(afname, 'w')
    for a in ARGUMENTS.iteritems():
        print >>f, "%s=%s" % a,
    print >>f
    f.close()

def tgt_guess():
    p = subprocess.Popen(['./config.guess'], stdout=subprocess.PIPE)
    o = p.communicate()[0]
    if p.returncode != 0:
        Exit(1)
    return o.strip()

def tgt_canonicalize(alias):
    p = subprocess.Popen(['./config.sub', alias], stdout=subprocess.PIPE)
    o = p.communicate()[0]
    if p.returncode != 0:
        Exit(1)
    return o.strip()

build_alias = ARGUMENTS.get('build', None)
if build_alias == None:
    build_alias = tgt_guess()
build = tgt_canonicalize(build_alias)
(build_cpu, build_vendor, build_os) = build.split('-', 2)
    
host_alias = ARGUMENTS.get('host', None)
if host_alias == None:
    host_alias = build_alias
host = tgt_canonicalize(host_alias)
(host_cpu, host_vendor, host_os)  = host.split('-', 2)


sourcedir=Dir(".").abspath
builddir=Dir(ARGUMENTS.get('builddir', '#obj/' + host)).abspath

SConsignFile(builddir + '/.sconsign')

try:
    Execute(Mkdir(builddir))
except:
    pass

# Only save args when doing the default build process.
if (len(COMMAND_LINE_TARGETS) == 0):
    log_args(builddir + '/.scons_build_args')

# XXX TODO: Make initial CPPPATH/LIBPATH derive from
# autodetected host system *or* command line.
#env = Environment(
#		  TOOLS = ['default', 'autotest', 'clntgen', 'tgtgen',
#		           'TOOL_SUBST'],
#		  ENV = os.environ,
#		  BUILDDIR = builddir,
#		  CPPPATH=['/usr/local/include', '$BUILDDIR'],
#		  LIBPATH=['usr/lib', '/usr/local/lib'],
#		  variables = vars)

env = Environment(
		  TOOLS = ['default', 'autotest', 'clntgen', 'tgtgen',
		           'TOOL_SUBST'],
		  ENV = os.environ,
		  BUILDDIR = builddir,
		  CPPPATH=['$BUILDDIR'],
		  LIBPATH=['usr/lib'],
		  variables = vars)

prefix = env['prefix']

print 'Build System Type: ', build
print 'Host System Type:  ', host
print 'Source path:       ', sourcedir
print 'Build path:        ', builddir
print 'Install prefix:    ', prefix

env['DESTDIR'] = ARGUMENTS.get('DESTDIR', '')

# Provide mechanism to override CC, CXX, etc.
if ARGUMENTS.get('CC', None):
    env['CC'] = ARGUMENTS.get('CC')
print 'CC:               ', env['CC']

if ARGUMENTS.get('CXX', None):
    env['CXX'] = ARGUMENTS.get('CXX')
print 'CXX:              ', env['CXX']

if ARGUMENTS.get('RANLIB', None):
    env['RANLIB'] = ARGUMENTS.get('RANLIB')
print 'RANLIB:           ', env['RANLIB']

if ARGUMENTS.get('AR', None):
    env['AR'] = ARGUMENTS.get('AR')
    print 'AR:               ', env['AR']

if ARGUMENTS.get('LD', None):
    env['LD'] = ARGUMENTS.get('LD')
    print 'LD:               ', env['LD']


env['STRIP'] = ARGUMENTS.get('STRIP', 'strip')
print 'STRIP:            ', env['STRIP']

if env['strip']:
    env['strip'] = True
print 'Strip binaries:   ', env.has_key('strip')

# POSIX strip has no options by the strict letter of the law.
# Assume we have GNU binutils strip until proven otherwise.
gnustrip = True
env['_STRIP_UNNEEDED'] = ""
if gnustrip:
    env['_STRIP_UNNEEDED'] = "--strip-unneeded"

# User can override this. Defaults to gcc's -O1, as this trims
# most of the template fat.
print 'Optimize code:    ', env['optimize']

# Default to disable; wrapper for compiler profiling support.
print 'Profile code:     ', env['profile']

# Default to local (UNIX domain sockets).
print 'Default XRL transport:', env['transport']

# Most of our shared library tweaks are specific to GNU ld.
# Check if the GNU linker is available, and print a warning if not.
if env['shared']:
    if SCons.Tool.FindTool(['gnulink'], env) is None:
        print gnutoolwarning % 'ld linker'
    env['SHAREDLIBS'] = "defined"
print 'Shared libraries: ', env.has_key('SHAREDLIBS')
print 'Use rtld ORIGIN:  ', env['rtld_origin']

# AUTOTEST_SKIP_ERRORS is SetDefault() by site_scons/site_tools/autotest.py,
# so print its value here.
if env['ignore_check_errors']:
    env['AUTOTEST_SKIP_ERRORS'] = True
print 'Ignore check errors: ', env['AUTOTEST_SKIP_ERRORS']

# NOTE: Enabling debug messages for the whole tree may not be what you want,
# as it can lead to premature timeouts.
# Enabling callback debugging is currently not advised as it does
# inline printfs.
print 'Debug symbols:    ', env['debug']
print 'Debug STL:        ', env['debug_stl']
print 'Debug messages:   ', env['debug_msg']
print 'Debug function names: ', env['debug_fn']
print 'Debug callbacks:  ', env['debug_cb']
print 'Debug XRL syntax: ', env['debug_xrldb']
print 'Enable OLSR:      ', env['enable_olsr']
print 'Enable OSPF:      ', env['enable_ospf']
print 'Enable RIP:       ', env['enable_rip']
print 'Enable VRRP:      ', env['enable_vrrp']
print 'Enable xorpsh     ', env['enable_xorpsh']
print 'Enable Test Programs: ', env['enable_tests']
print 'Enable CLICK:     ', env['enable_click']
print 'Enable FEA Dummy: ', env['enable_fea_dummy']
print 'Enable BGP:       ', env['enable_bgp']
print 'Try Enable BOOST: ', env['enable_boost']
print 'Try Enable uSTL : ', env['enable_ustl']
print 'Disable IPv6:     ', env['disable_ipv6']
print 'Disable libtecla: ', env['disable_libtecla']
print 'Disable Firewall: ', env['disable_fw']
print 'Disable Profile : ', env['disable_profile']
print 'Disable warning logs : ', env['disable_warninglogs']
print 'Disable error logs : ', env['disable_errorlogs']
print 'Disable trace logs : ', env['disable_tracelogs']
print 'Disable fatal logs : ', env['disable_fatallogs']
print 'Disable info logs : ', env['disable_infologs']
print 'Disable assert logs : ', env['disable_assertlogs']
print 'Disable other logs : ', env['disable_otherlogs']


env['CONFIGURELOG'] = str(builddir) + os.sep + 'config.log'
env['CONFIGUREDIR'] = str(builddir) + os.sep + '.sconf_temp'

SConsEnvironment.Chmod = SCons.Action.ActionFactory(os.chmod,
    lambda dest, mode: 'Chmod("%s", 0%o)' % (dest, mode))

def Symlink(src, link_name):
    try:
        os.unlink(link_name)
    except OSError:
        pass
    os.symlink(src, link_name)
SConsEnvironment.Symlink = SCons.Action.ActionFactory(Symlink,
    lambda src, link_name: 'Symlink("%s", as "%s")' % (src, link_name))

def InstallProgram(env, dest, files, perm = 0755):
    if env.has_key('DESTDIR'):
    	# NB: use simple concatenation
    	dest = env.Dir(env['DESTDIR'] + env.Dir(dest).path)
    obj = env.Install(dest, files)
    for i in obj:
	env.AddPostAction(i, env.Chmod(str(i), perm))
	if env['strip']:
	    env.AddPostAction(i, Action("$STRIP $TARGET"))
    return obj 
SConsEnvironment.InstallProgram = InstallProgram

def InstallScript(env, dest, files, perm = 0555):
    if env.has_key('DESTDIR'):
    	# NB: use simple concatenation
    	dest = env.Dir(env['DESTDIR'] + env.Dir(dest).path)
    obj = env.Install(dest, files)
    for i in obj:
	env.AddPostAction(i, env.Chmod(str(i), perm))
    return obj 
SConsEnvironment.InstallScript = InstallScript

## xorp 1.8.5

=== SConstruct ===
--- 
+++ 
@@ -1,4 +1,4 @@
-#Copyright (c) 2009-2011 XORP, Inc and Others
+#Copyright (c) 2009-2012 XORP, Inc and Others
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License, Version 2, June
@@ -84,6 +84,7 @@
     BoolVariable('enable_boost',  'Use BOOST', False),
     BoolVariable('enable_ustl',  'Use uSTL', False),
     BoolVariable('enable_bgp',  'Build BGP', True),
+    BoolVariable('enable_buildinfo',  'Build Info, see libxorp/create_buildinfo.sh', True),
     BoolVariable('enable_olsr',  'Build OLSR', True),
     BoolVariable('enable_ospf',  'Build OSPF', True),
     BoolVariable('enable_rip',  'Build RIP', True),
@@ -92,11 +93,12 @@
     BoolVariable('enable_tests',  'Build Test Programs', False),
     BoolVariable('enable_click',  'Build CLICK support', False),
     BoolVariable('enable_fea_dummy',  'Build fea-dummy target', True),
+    BoolVariable('enable_async_server',  'Permit asynchronous method implementations', False),
     BoolVariable('debug_xrldb',  'Build with runtime XRL syntax validation in Router Manager', False),
     EnumVariable('debug', 'Build with debug symbols', 'full',
                  allowed_values=('no', 'yes', 'full', 'override'),
                  map={}, ignorecase=2),
-    EnumVariable('optimize', 'Build with optimization', 'yes',
+    EnumVariable('optimize', 'Build with optimization', 'full',
                  allowed_values=('no', 'minimal', 'yes', 'full', 'highest',
                                  'size', 'override'),
                  map={}, ignorecase=2),
@@ -267,7 +269,9 @@
 print 'Enable Test Programs: ', env['enable_tests']
 print 'Enable CLICK:     ', env['enable_click']
 print 'Enable FEA Dummy: ', env['enable_fea_dummy']
+print 'Enable async method impls: ', env['enable_async_server']
 print 'Enable BGP:       ', env['enable_bgp']
+print 'Enable BuildInfo: ', env['enable_buildinfo']
 print 'Try Enable BOOST: ', env['enable_boost']
 print 'Try Enable uSTL : ', env['enable_ustl']
 print 'Disable IPv6:     ', env['disable_ipv6']
@@ -311,12 +315,3 @@
 SConsEnvironment.InstallProgram = InstallProgram
 
 def InstallScript(env, dest, files, perm = 0555):
-    if env.has_key('DESTDIR'):
-    	# NB: use simple concatenation
-    	dest = env.Dir(env['DESTDIR'] + env.Dir(dest).path)
-    obj = env.Install(dest, files)
-    for i in obj:
-	env.AddPostAction(i, env.Chmod(str(i), perm))
-    return obj 
-SConsEnvironment.InstallScript = InstallScript
-

=== devnotes/Makefile ===
TARGETS =	 							      \
	  management.ps 						      \
	  error_handling.ps  						      \
	  urib-interface.ps 

all: $(TARGETS)

clean:
	rm -f *.aux *.bbl *.blg *.dvi *.log $(TARGETS)

urib-interface.ps:	urib-interface.dvi
	dvips -o urib-interface.ps urib-interface.dvi
urib-interface.dvi:	urib-interface.tex

management.ps:	management.dvi
	dvips -o management.ps management.dvi
management.dvi:	management.tex management_diag1.tex
management_diag1.tex: management_diag1.pic
	pic -t management_diag1.pic > management_diag1.tex

# -----------------------------------------------------------------------------
# Implicit rules
# -----------------------------------------------------------------------------

%.ps: %.dvi
	dvips -o $@ $<

%.eps: %.fig
	fig2dev -Leps $< $@

%.ps: %.fig
	fig2dev -Lps $< $@

%.dvi: %.tex
	latex $<
	-bibtex $*
	latex $<
	latex $<

## xorp 1.8.6~wip.20160715

=== SConstruct ===
--- 
+++ 
@@ -40,6 +40,7 @@
 
 import sys
 import os
+import shutil
 import string
 import subprocess
 import fnmatch
@@ -81,11 +82,16 @@
     BoolVariable('disable_errorlogs',  'Force disable error logs', False),
     BoolVariable('disable_otherlogs',  'Force disable other logs', False),
     BoolVariable('disable_profile',  'Disable Xorp Profiler feature', False),
+    BoolVariable('disable_werror',  'Disable -Werror compiler flag', False),
+    BoolVariable('disable_assert',  'Force disabling assertions - use with caution', False),
+    BoolVariable('enable_lex_hack',  'Works around lex/yacc issues on FreeBSD', False),
+    BoolVariable('enable_builddirrun',  'Enable Xorp to run from BUILD_DIR', False),
     BoolVariable('enable_boost',  'Use BOOST', False),
     BoolVariable('enable_ustl',  'Use uSTL', False),
     BoolVariable('enable_bgp',  'Build BGP', True),
     BoolVariable('enable_buildinfo',  'Build Info, see libxorp/create_buildinfo.sh', True),
     BoolVariable('enable_olsr',  'Build OLSR', True),
+    BoolVariable('enable_wrapper',  'Build Wrapper', True),
     BoolVariable('enable_ospf',  'Build OSPF', True),
     BoolVariable('enable_rip',  'Build RIP', True),
     BoolVariable('enable_vrrp',  'Build VRRP', True),
@@ -93,6 +99,7 @@
     BoolVariable('enable_tests',  'Build Test Programs', False),
     BoolVariable('enable_click',  'Build CLICK support', False),
     BoolVariable('enable_fea_dummy',  'Build fea-dummy target', True),
+    BoolVariable('enable_viff_use_ifindex',  'Use VIFF_USE_IFINDEX feature in Linux kernel 2.6.31+', False),
     BoolVariable('enable_async_server',  'Permit asynchronous method implementations', False),
     BoolVariable('debug_xrldb',  'Build with runtime XRL syntax validation in Router Manager', False),
     EnumVariable('debug', 'Build with debug symbols', 'full',
@@ -138,7 +145,7 @@
     build_alias = tgt_guess()
 build = tgt_canonicalize(build_alias)
 (build_cpu, build_vendor, build_os) = build.split('-', 2)
-    
+
 host_alias = ARGUMENTS.get('host', None)
 if host_alias == None:
     host_alias = build_alias
@@ -181,6 +188,8 @@
 		  variables = vars)
 
 prefix = env['prefix']
+
+env['builddir'] = builddir;
 
 print 'Build System Type: ', build
 print 'Host System Type:  ', host
@@ -262,6 +271,7 @@
 print 'Debug callbacks:  ', env['debug_cb']
 print 'Debug XRL syntax: ', env['debug_xrldb']
 print 'Enable OLSR:      ', env['enable_olsr']
+print 'Enable Wrapper:   ', env['enable_wrapper']
 print 'Enable OSPF:      ', env['enable_ospf']
 print 'Enable RIP:       ', env['enable_rip']
 print 'Enable VRRP:      ', env['enable_vrrp']
@@ -269,15 +279,19 @@
 print 'Enable Test Programs: ', env['enable_tests']
 print 'Enable CLICK:     ', env['enable_click']
 print 'Enable FEA Dummy: ', env['enable_fea_dummy']
+print 'Enable VIFF_USE_IFINDEX: ', env['enable_viff_use_ifindex']
 print 'Enable async method impls: ', env['enable_async_server']
 print 'Enable BGP:       ', env['enable_bgp']
 print 'Enable BuildInfo: ', env['enable_buildinfo']
+print 'Xorp can run from BUILD_DIR: ', env['enable_builddirrun']
 print 'Try Enable BOOST: ', env['enable_boost']
 print 'Try Enable uSTL : ', env['enable_ustl']
 print 'Disable IPv6:     ', env['disable_ipv6']
 print 'Disable libtecla: ', env['disable_libtecla']
 print 'Disable Firewall: ', env['disable_fw']
 print 'Disable Profile : ', env['disable_profile']
+print 'Disable -Werror : ', env['disable_werror']
+print 'Enable lex hack : ', env['enable_lex_hack']
 print 'Disable warning logs : ', env['disable_warninglogs']
 print 'Disable error logs : ', env['disable_errorlogs']
 print 'Disable trace logs : ', env['disable_tracelogs']
@@ -285,33 +299,7 @@
 print 'Disable info logs : ', env['disable_infologs']
 print 'Disable assert logs : ', env['disable_assertlogs']
 print 'Disable other logs : ', env['disable_otherlogs']
+print 'Disable assert: ', env['disable_assert']
 
 
 env['CONFIGURELOG'] = str(builddir) + os.sep + 'config.log'
-env['CONFIGUREDIR'] = str(builddir) + os.sep + '.sconf_temp'
-
-SConsEnvironment.Chmod = SCons.Action.ActionFactory(os.chmod,
-    lambda dest, mode: 'Chmod("%s", 0%o)' % (dest, mode))
-
-def Symlink(src, link_name):
-    try:
-        os.unlink(link_name)
-    except OSError:
-        pass
-    os.symlink(src, link_name)
-SConsEnvironment.Symlink = SCons.Action.ActionFactory(Symlink,
-    lambda src, link_name: 'Symlink("%s", as "%s")' % (src, link_name))
-
-def InstallProgram(env, dest, files, perm = 0755):
-    if env.has_key('DESTDIR'):
-    	# NB: use simple concatenation
-    	dest = env.Dir(env['DESTDIR'] + env.Dir(dest).path)
-    obj = env.Install(dest, files)
-    for i in obj:
-	env.AddPostAction(i, env.Chmod(str(i), perm))
-	if env['strip']:
-	    env.AddPostAction(i, Action("$STRIP $TARGET"))
-    return obj 
-SConsEnvironment.InstallProgram = InstallProgram
-
-def InstallScript(env, dest, files, perm = 0555):

=== debian/changelog ===
xorp (1.8.6~wip.20160715-2ubuntu2) bionic; urgency=high

  * No change rebuild against openssl1.1.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 05 Feb 2018 16:55:56 +0000

xorp (1.8.6~wip.20160715-2ubuntu1) yakkety; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Build for all architectures.
  * Dropped changes, included in Debian:
    - Build using autotools-dev.
    - Drops build-dependency on gcc-4.6.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 27 Jul 2016 17:59:48 +0200

xorp (1.8.6~wip.20160715-2) unstable; urgency=low

  * Add dh_update_autotools_config for trying to build on ppc64el.
  * Increase versioned depends on debhelper.

 -- Jose M Calhariz <jose@calhariz.com>  Sat, 23 Jul 2016 22:00:43 +0100

xorp (1.8.6~wip.20160715-1) unstable; urgency=low

  * New upstream release, (Closes: #811943)
  * Update email of Maintainer.
  * wrap-and-sort -at.
  * Bump Standards-Version 3.9.8 nothing changed.
  * Drop patches fea_mfea_mrouter.cc__build_with_gcc-4.7, use_cpp-4.6 and
    experimental_ftbfs_cpp-4.7 because they are no longer needed.
  * Fix lintian error
    maintainer-script-should-not-use-adduser-system-without-home.
  * Don't "scons -c" if file libxorp/build_info.cc don't exist.
  * xorp now Build-Depends on bison and flex.
  * Enable hardening build flags, thanks to Dhionel Díaz
    <ddiaz@cenditel.gob.ve> for the patch to support CPPFLAGS.  (Closes:
    #798902).
  * Add support to systemd (Closes: #798802), thank you Dhionel Díaz for
    the patches.
  * Acknwoledge NMU, thank you Matthias Klose <doko@debian.org>.
  * Make build reproducible, (Closes: #831429).
  * Increase compat level to 9.
  * Drop old Buil-Depends on quilt.
  * Updated the list or support architectures, add pcc64el and replace
    s390 by s390x.
  * Drop patches accepted by upstream fix-return-void
    fix-route_table_ribin.cc-lookup_route-misleading-indentation
    fix-trie.hh-find-bounds-mislideading-indentation.
  * Disable -Werr and remove -Wno-error=*.
  * Removed obsolete READMEs.
  * Removed helper files for backport, gone obsolete.
  * Removed personal targets and variables from debian/rules.

 -- Jose M Calhariz <jose@calhariz.com>  Fri, 22 Jul 2016 22:18:18 +0100

xorp (1.8.5-4.1ubuntu1) wily; urgency=medium

  * Merge from Debian unstable, remaining changes:
    - Build using autotools-dev.
    - Build for all architectures.
  * Drops build-dependency on gcc-4.6.  LP: #1459952.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 17 Aug 2015 05:53:41 +0200

xorp (1.8.5-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/rules: Handle GCC releases >= 5. Closes: #778188.
  * Build with -ftemplate-depth=30.
  * Build with -Werror=sizeof-array-argument.
  * Rename out_of_range to xorp_out_of_range.

 -- Matthias Klose <doko@debian.org>  Wed, 08 Jul 2015 17:07:51 +0200

xorp (1.8.5-4ubuntu2) utopic; urgency=medium

  * Build using autotools-dev.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 12 Sep 2014 15:10:43 +0200

xorp (1.8.5-4ubuntu1) utopic; urgency=medium

  * Merge with Debian; remaining changes:
    - Build for all architectures.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 11 Sep 2014 22:47:01 +0200

xorp (1.8.5-4) unstable; urgency=low

  * Change email of Maintainer.
  * Update rules file to version 0.27.
  * experimental_ftbfs_cpp-4.7: experimental patch to make xorp compile
    with cpp 4.7 or better.

 -- Jose M Calhariz <jose.calhariz@netvisao.pt>  Tue, 09 Sep 2014 12:48:18 +0100

xorp (1.8.5-3) unstable; urgency=low

  * Add support to build with GCC 4.9 (Closes: #746922).
  * Rebuild without build-depend on cpp-4.6 (Closes: #747993).
  * Update Maintainer address.
  * Bump Standards-Version to 3.9.5, no changes needed.

 -- Jose M Calhariz <jose.calhariz@ist.utl.pt>  Sat, 23 Aug 2014 20:47:52 +0100

xorp (1.8.5-2) unstable; urgency=low

  * Remade the previous work around to build with GCC 4.7 and 4.8, now use
    only cpp-4.6.
  * Fix bashism on bgp_xrl_shell_funcs.sh and fea_xrl_shell_funcs.sh
    scripts (Closes: #690647).
  * Make init.d more LSB compliant (Closes: #693776).

 -- Jose M Calhariz <jose.calhariz@ist.utl.pt>  Fri, 16 Aug 2013 19:51:12 +0100

xorp (1.8.5-1.1) unstable; urgency=low

  * Non maintainer upload
  * Work around build failure with GCC 4.7. Closes: #667423.

 -- Matthias Klose <doko@debian.org>  Mon, 28 May 2012 13:44:30 +0000

xorp (1.8.5-1) unstable; urgency=low

  * New upstream release
    - Remove upstream's tmp/ directory which contains unused content
    (XORP modular router with improvements to better support LANforge.)
  * Remove patches for FTBFS on gcc 4.6, where accepted by upstream.
  * Remove obsolete patch xorpsh.1_fix_typo.

 -- Jose Calhariz <jose.calhariz@tagus.ist.utl.pt>  Mon, 13 Feb 2012 20:41:33 +0000

xorp (1.8.3-1) unstable; urgency=low

  * Updated manpages with the new options.
  * SNMP support was dropped from xorp, so closing (Closes: #563944).
  * Added build-arch and build-indep rules.

 -- Jose Calhariz <jose.calhariz@tagus.ist.utl.pt>  Sun, 21 Aug 2011 21:27:11 +0100

xorp (1.8.3-1~wip5) experimental; urgency=low

  * New upstream release.
  * Don't depend on daemon (Closes: #611227).
  * Move xorp preinst to postinst for setting up proper ownership of
    /etc/xorp during fresh installs (Closes: #611231).
  * Give write permissions to group xorp as suggested on bug report
    #611231.
  * Removes old obsolete patches.
  * Solve FTBFS with g++ v4.6 (Closes: #625437).
  * Remove rules for building indep packages, upstream don't ship anymore
    documentation.
  * Created patches for compiling the checks with g++ v4.6
  * Standards Version updated to 3.9.2, no changes needed.
  * Fetch manpages from upstream git into debian directory and create man
    pages from sgml files.
  * Dropped depends on libsnmp-dev, the support was removed from xorp.
  * Increase debhelper compatibility to v7 as is supported on lenny, may
    lower to 5 for building on etch.


=== debian/control ===
Source: xorp
Section: net
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Jose M Calhariz <jose@calhariz.com>
Uploaders: Javier Fernandez-Sanguino Pen~a <jfs@debian.org>,
Build-Depends: autotools-dev,
               bison,
               debhelper (>= 9.20160114),
               dh-systemd,
               docbook-to-man,
               flex,
               libboost-dev,
               libncurses5-dev | ncurses-dev,
               libpcap0.8-dev,
               libssl-dev,
               libsystemd-dev,
               pkg-config,
               scons,
Build-Conflicts: iptables-dev,
Standards-Version: 3.9.8
Homepage: http://www.xorp.org
Vcs-Svn: svn://anonscm.debian.org/pkg-xorp/trunk/xorp
Vcs-Browser: https://anonscm.debian.org/viewsvn/pkg-xorp/trunk/xorp/

Package: xorp
Architecture: any
Depends: adduser (>= 3.11),
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: iputils-ping,
            iputils-tracepath,
            traceroute,
Description: eXtensible Open Router Platform
 XORP is the eXtensible Open Router Platform. It implements a number of
 routing protocols for IPv4 and IPv6 and a unified means to configure them. It
 is stable and fully featured enough for production use, and flexible and
 extensible enough to enable network research.
 .
 The following network protocols are currently
 supported: BGP, OSPF, RIP/RIPng, IGMP/MLD and PIM-SM.
 .

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

#For overriding debian/compat
#export DH_COMPAT=7

#This rule file have a bashism
SHELL:=/bin/bash

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DPKG_EXPORT_BUILDFLAGS = 1
-include /usr/share/dpkg/buildflags.mk

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

# Personal Variables
PACKNAME=$(shell dh_listpackages)
PACKAGE=$(shell dh_listpackages)

# Variables used by the Debian Maintainer exclusively for package
# development.
SOURCENAME=$(shell dpkg-parsechangelog | grep "Source:" | cut -d ' ' -f 2)
DEBVER=$(shell dpkg-parsechangelog | grep "Version:" | cut -d ' ' -f 2)
VER=$(shell dpkg-parsechangelog | grep "Version:" | cut -d ' ' -f 2 | cut -f 1 -d -)


SCONS=scons
SCONSFLAGS=prefix=/usr \
		bindir=/usr/bin sbindir=/usr/sbin \
		mandir=/usr/share/man infodir=/usr/share/info \
		sysconfdir=/etc \
		with-olsr=true \
		disable_fw=true \
		enable_systemd=true \
		disable_werror=true \
		CPPFLAGS="$(CPPFLAGS)" CFLAGS="$(CFLAGS)" \
		CXXFLAGS="$(CXXFLAGS)" LDFLAGS="$(LDFLAGS)"

CXXFLAGS += -std=gnu++98


config.status:
	dh_testdir
	# Add here commands to configure the package.


build: build-arch build-indep

build-indep: build-indep-stamp
build-indep-stamp:
	# Upstream dropped documentation out of source code
	touch $@


build-arch:  build-arch-stamp
build-arch-stamp:  config.status
	dh_testdir
	dh_update_autotools_config
	# Compile the package
	$(SCONS) $(SCONSFLAGS)
	docbook-to-man debian/xorp_rtrmgr.sgml > debian/xorp_rtrmgr.8
	docbook-to-man debian/xorpsh.sgml > debian/xorpsh.1
	touch $@


check:
	$(SCONS) $(SCONSFLAGS) check



clean: 
	dh_testdir
	dh_testroot
	# Add here commands to clean up after the build process.
	[ ! -e ./libxorp/build_info.cc ] || $(SCONS) $(SCONSFLAGS) -c
	rm -rf obj
	rm -f config.status config.log build-arch-stamp build-indep-stamp
	rm -f relpath.pyc site_scons/*/*.pyc
	rm -f xrl/scripts/Xif/*.pyc
	dh_clean 


install: install-arch


install-arch:
	dh_testdir
	dh_testroot
	#dh_clean -k -a
	dh_prep
	dh_installdirs -a
	# Install the program:
	$(SCONS) $(SCONSFLAGS) \
		DESTDIR=$(CURDIR)/debian/$(SOURCENAME) install

	# After the install, we move the files and create the symlinks : 
	for file in rib_xrl_shell_funcs.sh fea_xrl_shell_funcs.sh bgp_xrl_shell_funcs.sh ; do mv debian/$(SOURCENAME)/usr/sbin/$$file debian/$(SOURCENAME)/usr/lib/xorp/bin/   ; done
	cd debian/$(SOURCENAME)/usr/sbin/ && find -type f -exec ln -vsf /usr/sbin/{} ../lib/xorp/bin/ \; && cd $(CURDIR)
	# Config files: 
	cp debian/config.boot.small debian/$(SOURCENAME)/etc/xorp/config.boot
	cp debian/$(SOURCENAME).default debian/$(SOURCENAME)/etc/default/xorp
	cp debian/$(SOURCENAME).init.d  debian/$(SOURCENAME)/etc/init.d/xorp
	dh_install -s


# Must not depend on anything. This is to be called by
# binary-arch/binary-indep
# in another 'make' thread.
binary-common:
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installexamples -pxorp rtrmgr/config/*.boot debian/config.boot.mcast  rtrmgr/config/README
	dh_installlogrotate
	dh_systemd_enable
	dh_installinit
	dh_systemd_start
	dh_installman 
	dh_link
	dh_strip
	dh_compress 
	dh_fixperms
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps -l/usr/lib/xorp/lib
	dh_gencontrol
	dh_md5sums
	dh_builddeb


# Build architecture dependant packages using the common target.
binary-arch: build-arch-stamp install-arch
	$(MAKE) -f debian/rules DH_OPTIONS=-a binary-common


binary: binary-arch

.PHONY: build clean binary-indep binary-arch binary install
